cc.Class({
    extends: cc.Component,

    properties: {
        label: {
            default: null,
            type: cc.Label
        },

        sprite: {
            default: null,
            type: cc.Sprite
        },

        // defaults, set visually when attaching this script to the Canvas
        text: 'Hello, World!'
    },

    // use this for initialization
    onLoad: function () {
        this.label.string = this.text;
    },

    start () {

        var circleSPF = this.getCircleSpriteFrame(100, 100, this.node, cc.Color.RED);

        if (circleSPF !== null)
        {
            this.sprite.spriteFrame = circleSPF;
        }
    },

    // called every frame
    update: function (dt) {

    },

    getCircleSpriteFrame (width, height, tmpNode, color) {

        width = Math.floor(width);
        height = Math.floor(height);

        var size = new cc.Size(width, height);

        //cc.Texture2D.PIXEL_FORMAT_RGBA8888, gl.DEPTH24_STENCIL8_OES
        var renderTexture = cc.RenderTexture.create(width, height);

        renderTexture.begin();

        var node = new cc.Node('Graphics');

        cc.log('Test - 1');

        var graphics = node.addComponent(cc.Graphics);
        graphics.fillColor = color || cc.Color.WHITE;
        graphics.circle(width/2, height/2, width/2);
        graphics.fill(); 

        node.parent = tmpNode;

        node._sgNode.visit();

        renderTexture.end();

        let cst = renderTexture.getSprite().getTexture();

        cc.log('Test - 2' + cst);

        let tsize = cst.getContentSize();

        cc.log('Test - 3' + tsize);

        var sf = new cc.SpriteFrame(cst, cc.rect(0,0,width,height), false, cc.p(0,0), cc.size(width,height));

        cc.log('Test - 4' + sf);

        node.parent = null;

        return sf;
    },
});
